function [WHI,WOI,WOH,BiasH,BiasO]=bpc2(WHI,WOI,WOH,BiasH,BiasO,INPD,OUTD);
% Rotina para treinar rede neural com 1 camada escondida
% COM ligacoes diretas entre as camadas de entrada e de saida
% Rotinas auxiliares: ord.m, nnout2.m
% Autores: Eduardo Botter e Cairo L. Nascimento Jr. - ITA - cairo@ita.br
% Data: 22/Fev/1995, Matlab 4.x
%       11/Out/2001, Adicao da ligacao direta entre as camadas de entrada e de saida
%       10/Fev/2002, Revisao para Matlab 5.x

global npat nord netah netao netadec biasder;

    % Escolha um dos padroes de treinamento
    % e treine a rede com este padrao por 1 iteracao
    % Assumindo treinamento com ordenacao sequencial
    ordpat=[1:npat];
    if nord > 0 & npat > 1;  % treinamento com ordenacao aleatoria
       [ordpat2,ord2]=ord(ordpat);
       ordpat=ordpat2;
    end;
    %fprintf('%3i [ord = %2i %2i %2i %2i] ',iter, ordpat);

    for ipat=1:npat;

        Inppat=INPD(:,ordpat(ipat));
        [Outpat,OutH]=nnout2(WHI,WOI,WOH,BiasH,BiasO,Inppat);
        Verro=OUTD(:,ordpat(ipat))-Outpat;

        % Calcule o delta das unidades de saida
        % dim Delta0 = nout,1
        DeltaO=-Verro.*(1-Outpat.*Outpat+biasder);

        % Calcule o delta das unidades escondidas
        % SumDeltaWoh = somatoria dos pesos enviados por cada unidade
        %   escondida multiplicados pelos deltas das unidades escondidas
        %   que recebem estes pesos
        % dim SumDeltaWoh = nhid,1 = (nout,nhid)'*(nout,1)
        SumDeltaWoh=WOH'*DeltaO;
        % dim DeltaH = nhid,1
        DeltaH=SumDeltaWoh .* (1-OutH.*OutH+biasder);

        WHI=WHI-netah*DeltaH*Inppat'-netadec*WHI;
        WOI=WOI-netao*DeltaO*Inppat'-netadec*WOI;
        WOH=WOH-netao*DeltaO*OutH'-netadec*WOH;
        BiasH=BiasH-netah*DeltaH-netadec*BiasH;
        BiasO=BiasO-netao*DeltaO-netadec*BiasO;

    end;

% EOF bpc2.m
