function [OutpatO,OutpatH]=nnout2(WHI,WOI,WOH,BiasH,BiasO,Inppat)
% Assumindo: - apenas 1 camada escondida,
%            - COM ligacoes diretas entre as camadas de entrada e de saida,
%            - unidades escondidas e de saida usam funcao tangente hiperbolica.
% Inppat = vetor coluna com o padrao de entrada da rede
% OutpatH = vetor coluna com as saidas das unidades escondidas
% OutpatO = vetor coluna com o padrao de saida da rede
% Autores: Eduardo Botter e Cairo L. Nascimento Jr. - ITA - cairo@ita.br
% Data: 22 Fev 1995, Matlab 4.x
%       11 Out 2001, Adicao da ligacao direta entre as camadas de entrada e de saida
%       10 Fev 2002, Revisao para Matlab 5.x

NetH=WHI*Inppat+BiasH;
OutpatH=tanh(NetH);
NetO=WOI*Inppat+WOH*OutpatH+BiasO;
OutpatO=tanh(NetO);

% EOF nnout2.m


