% Instituto Tecnolgico de Aeronutica
% Departamento de Sistemas e Controle
% 
% Disciplina: Inteligncia Artificial em Automao e Controle - 2001/01
% Professor:  Cairo Lcio Nascimento Junior
% Aluno:		  Fbio Meneghetti U. de Arajo
%
%
% 		Programa para treinar uma RNA estritamente feedforward 
% utilizando o algoritimo Backpropagation para reconhecimento de
% comandos vocais.
%
% 		Verso 1.3 
%
%

clear all
close all
clc

% Estrutura da rede

uniesc = input(['Entre com o nmero unidades na camada escondida: ']);
disp(' ')
eta = input('Entre com a taxa de aprendizado: ');
disp(' ')
maxite = input('Entre com o nmero mximo de iteraes: ');
disp(' ')
mosres = input('Entre com o nmero de iteraes para vizualizao dos resultados: ');
disp(' ')
maxerr = input('Entre com o erro mdio quadrtico mximo permitido: ');
disp(' ')
disp('Tanto a camada escondida quanto a sada teram o mesmo tipo de unidades.')
resp = ' ';
while resp ~= 'ok'
   disp(' ')
   disp(['Escolha a funo de ativao destas unidades:']);
   disp(' ')
   funati = input('      [1] TANGENTE HIPERBLICA [2] SIGMOIDE: ');
   disp(' ')
   if  funati >= 1 & funati <= 2
      resp='ok';
   end
end
      
% ####################################################################

% Monta padro de treinamento
disp(' necessrio escolher os padores para montagem do conjunto de treinamento,')
disp(' ')
nai=input('Entre com o nmero do padro inicial para montagem do conjunto de treinamento ');
naf=input('Entre com o nmero do padro final para montagem do conjunto de treinamento ');
disp(' ')

[p_entrada,p_desejado,lband] = montconj(nai,naf,funati);

%numpad 	==>  Nmero de padres para o treinamento
%uniin 	==>  Nmero de unidades na camada de entrada
%uniout 	==>  Nmero de unidades na camada de sada

[numpad,uniin]=size(p_entrada);[numpad,uniout]=size(p_desejado);

resp = ' ';
while resp ~= 'ok'
   disp(' ')
   disp(['Escolha a forma de inicializao dos pesos:']);
   disp(' ')
   inipes = input('      [1] Inicalizar pesos aleatriamente [2] Usar pesos do workspace: ');
   disp(' ')
   
   t0=cputime;
   
   if  inipes == 1
      resp='ok';
      % Inicializa aleatoriamente os pesos e bias da rede
   	    pesout = randn(uniout, uniesc(1));
		bout = randn(uniout, 1);
		pesesc1 = randn(uniesc(1), uniin);
		besc1 = randn(uniesc(1), 1);
   elseif inipes == 2
      load rede;
      resp='ok';
   end
end

	iter = 0;
	erite = maxerr + 1;
   err = [];
   
disp(' ')
disp('-------------------------------------------------------------------')
disp(' ')

save traindat uniesc eta maxite mosres maxerr funati lband nai naf inipes pesout bout pesesc1 besc1
   
   % ************************* ITERAO ******************************
   while iter < maxite & erite > maxerr	% Fatores de parada: 
      												%	N de Iteraes
      												% 	ou erro mdio quadrtico.
		erite = 0;saiite = [];
      
		% Treina todos os padres na iterao
      for pad = 1 : numpad
  			entrada = p_entrada(pad,:)';desejado = p_desejado(pad,:)';

			% Calcula sadas das unidades escondidas
         net_esc1 = pesesc1 * entrada + besc1;
         
         if funati == 1										% Tangente hiperblica
            s_esc1 = tansig(net_esc1);
			elseif funati == 2								% Sigmide
				s_esc1 = logsig(net_esc1);
			end

			% Calcula sadas das unidades de sada
			net_saida = pesout * s_esc1 + bout;
         
         if funati == 1											% Tangente hiperblica
				saida = tansig(net_saida);
			elseif funati == 2									% Sigmide
				saida = logsig(net_saida);
			end

         % Calcula erro entre sadas desejadas e obtidas
			saierr = desejado - saida;
         % Calcula o delta da sada
			if funati == 1											% Tangente hiperblica
				delta_saida = saierr .* (1 - (saida .* saida));
			elseif funati == 2									% Sigmide
				delta_saida = saierr .* saida .* (1 - saida);
			end
         
         % Calcula erro para sadas da camada escondida
			erro_esc1 = pesout' * delta_saida;
			% Calcula o delta da camada escondida
			if funati == 1											% Tangente hiperblica
				delta_esc1 = erro_esc1 .* (1 - (s_esc1 .* s_esc1));
			elseif funati == 2									% Sigmide
				delta_esc1 = erro_esc1 .* s_esc1 .* (1 - s_esc1);
         end
         
         % Atualiza pesos da camada de sada
			pesout = pesout + eta * delta_saida * s_esc1';
			% Atualiza bias da camada de sada
			bout = bout + eta * delta_saida;
			% Atualiza pesos da camada escondida
			pesesc1 = pesesc1 + eta * delta_esc1 * entrada';
			% Atualiza bias da camada escondida
			besc1 = besc1 + eta * delta_esc1;
      end
      
      save redein pesesc1 besc1 pesout bout;					% Salva os dados da rede
      																	% Durante o treinamento.

	% -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -

		% Calcula os erros
		for pad = 1:numpad	
  			entrada = p_entrada(pad,:)';desejado = p_desejado(pad,:)';
           
         % Calcula sadas das unidades escondidas
			net_esc1 = pesesc1 * entrada + besc1;
         
         if funati == 1										% Tangente hiperblica
            s_esc1 = tansig(net_esc1);
			elseif funati == 2								% Sigmide
				s_esc1 = logsig(net_esc1);
			end
         
         % Calcula sada da unidade de sada
			net_saida = pesout * s_esc1 + bout;
         
         if funati == 1											% Tangente hiperblica
				saida = tansig(net_saida);
			elseif funati == 2									% Sigmide
				saida = logsig(net_saida);
			end

			saiite = [saiite saida];
			% Calcula erro entre sadas desejadas e obtidas
			saierr = desejado - saida;
			% Atualiza erro mdio quadrtico da iterao
			erite = erite + saierr' * saierr;
		end
		erite = erite / (numpad * uniout);
		% Guarda o erro das iteraes no vetor err
      err = [err erite];
      % Armazena as Superfcies de deciso
		iter = iter + 1;
      
      % =========== Mostra Resultado  da N-ssima Iterao ===========
      if iter / mosres == fix(iter / mosres) | iter == 1
%         pause
      % Sada em texto
         disp(['iteraes n ' num2str(iter) ' de ' num2str(maxite) ' => erro de ' num2str(erite)])
         
      % Sadas Grficas
         % Curva de Aprendizado
   		semilogy(err);hold on;plot([0 iter],[maxerr maxerr],'r--')
   		tit=(['Erro mdio quadrtico de ' num2str(erite) ' na ' num2str(iter) ' Iterao']);
   		title(tit);ylabel('Erro mdio quadrtico')
         ymx = 1.2 * max(err);ymn = .6 * maxerr;axis([0 iter ymn ymx]);
         pause(.1)
       
      end
 		% ==============================================================
       
      % *********************** FIM DA ITERAO **********************
   end
   
   % ==================  Mostra Resultado  Final  ==================== 
   disp(' ');
   disp(' ');
   disp('Os pesos finais, na camada escondida 1, so: ');
   disp(pesesc1');
   disp('e na camada de sada, so: ');
   disp(pesout')
	disp(' ');
   disp('Os bias finais, na camada escondida 1, so: ');
   disp(besc1');
   disp('e na camada de sada, so: ');
   disp(bout')
   disp(' ');
   disp(['O erro mdio quadrtico inicial foi de: ' num2str(err(1)) ', enquanto que:'])
   disp(['O erro mdio quadrtico final foi de: ' num2str(erite)])
   disp(' ');
   disp(['O nmero final de iteraes foi de: ' num2str(iter)])
   
   semilogy(err);hold on;plot([0 iter],[maxerr maxerr],'r--')
   tit=(['Erro mdio quadrtico de ' num2str(erite) ' na ' num2str(iter) ' Iterao']);
   title(tit);ylabel('Erro mdio quadrtico')
   ymx = 1.2 * max(err);ymn = .6 * maxerr;axis([0 iter ymn ymx]);
   disp(' ')
   tp=['tempo de processamento: ' num2str(cputime-t0) ' segundos'];
   disp(tp)
% =================================================================

save rede pesesc1 besc1 pesout bout;					% Salva os dados da rede no fim
