function [padin,padout,lband] = montconj(narqi,narqf,tf)

% Instituto Tecnolgico de Aeronutica
% Departamento de Sistemas e Controle
% 
% Disciplina: 	Inteligncia Artificial em Automao e Controle - 2001/01
% Professor: 	Cairo Lcio Nascimento Junior
% Aluno:			Fbio Meneghetti U. de Arajo
%
%
% Funo para montar conjunto de dados para treinamento e/ou teste 
% de uma rede neural para reconhecimeto de comando vocal.
%
%		function [padin,padout] = montconj(narqi,narqf,tf)
%
%		padin		-> Padro para entrada da rede
%		padout	    -> Padro para Sada da rede
%       lband       -> Largura das bandas escolhida
%		narqi		-> Nmero do primeiro arquivo do conjunto
%		narqf		-> Nmero do ltimo arquivo do conjunto
%		tf			-> Tipo de funo de ativao dos neornios da rede
%						1	->	Tangente Hiperblica
%						2	->	Sigmide
%
%


disp(' ')
lband = 500;
lband = input('Entre com a largura de faxa das bandas: ');


padin = [];     				% Padro de Treinamento ou de Teste
l_ent = 0;						% Linha da Matriz de padres

for numarq = narqi:narqf
   for comvoc = 1:5
      bonda = [];
      l_ent = l_ent + 1;
      if comvoc == 1
         cv = 'fr';
      elseif comvoc == 2
         cv = 're';
      elseif comvoc == 3
         cv = 'di';
      elseif comvoc == 4
         cv = 'es';
      else
         cv = 'pa';
      end
      arquiv = [cv num2str(numarq) '.wav'];			        % Determina arquivo a ser aberto
      [onda,freq,form] = wavread(arquiv);				    % Abre Arquivo
		fonda = abs(fft(onda,freq));     			    	% Aplica FFT na onda obtendo seu espctro .
		fonda = fonda(1 : ceil(length(fonda) / 2));     	% Corta a poro simtrica da FFT.

		for i = lband : lband : 3000 + lband				% Divide a parte mais representativa do 
         bonda = [bonda sum(fonda(i : i + lband -1))];	    % espctro (de 300 a mais de 3k Hz) em bandas com largura
      end													% de lband Hz e caucula-se o padra de energia em cada banda.
      if tf == 1
         bonda = (bonda /  max(bonda)) * 2 - 1; 	        % Normaliza a representao em bandas da onda entre -1 e 1.
      else
         bonda = bonda /  max(bonda); 					    % Normaliza a representao em bandas da onda entre 0 e 1.
      end
      padin(l_ent,:) = bonda;								% Monta Padro de entrada
      if tf == 1
         sai = -1 * ones(1,5);sai(comvoc) = 1;
      else
         sai = zeros(1,5);sai(comvoc) = 1;
      end
      padout(l_ent,:) = sai;								% Monta Padro de sada
   end
end
