% RL BOOTSTRAP para labirinto
% CLNJ - 22/jun/2004
% CLNJ - 23/ago/2004
% CLNJ - 26/ago/2004
clear all; close all;
hf(1)=figure(1);
%set(gcf,'Position',[  5  305   395   225]);
set(gcf,'DoubleBuffer','on'); % habilitar tracado mais rapido das linhas
                              % para mostrar animacoes em maquinas mais rapidas

% PASSO 1: leitura do labirinto no arquivo "labir.txt" e definicao do vetor
% de recompensas LAB_REC
% 0 = celula livre
% 1 = obstaculo
% 2 = ponto de recompensa negativa
% 3 = ponto de recompensa positiva
filename='labir.txt'; % Nome do arquivo que contem o labirinto
% Definicao dos parametros do vetor de recompensas LAB_REC
% O vetor LAB_REC define a recompensa obtida em cada passo por estar em uma
% determinada celula
rn=-0.5; rec_neginf=-100; rec_neg=-1; rec_pos=1; 
% Definicao dos parametros do metodo BOOTSTRAP LEARNING
NIterMax=600; NStepMax=30;
fid=fopen(filename,'rt');
if fid==-1;
   error(['Arquivo ' filename 'nao encontrado !!']);
end;
Size_Lab=fscanf(fid,'%i %i',2);
Nl=Size_Lab(1);
Nc=Size_Lab(2);
ic=1;
for i=1:Nl;
    for j=1:Nc;
        LAB(i,j)=fscanf(fid,'%i ',1); % codigo do tipo da celula
        LAB_REC(ic)=rn; 
        if LAB(i,j) == 1; LAB_REC(ic)=rec_neginf; end;
        if LAB(i,j) == 2; LAB_REC(ic)=rec_neg; end;
        if LAB(i,j) == 3; LAB_REC(ic)=rec_pos; end;
        ic=ic+1;
    end;
end;
fclose(fid);

% PASSO 2: Criacao da matriz LAB_POS
% A matriz LAB_POS define o labirinto
% A linha i contem a numeracao das celulas apontadas pela celula i
% na sequencia dos movimentos: right, up, left, down.
% Um movimento que tem como resultado a propria celula de origem
% indica que o movimento nao pode ser executado
% A numeracao das linhas e das colunas segue a convencao de matrizes,
% ou seja, linhas numeradas de cima para baixo e colunas numeradas
% da esquerda para a direita
ic=1;
for i=1:Nl;
    for j=1:Nc;
        LAB_POS(ic,:)=[ic ic ic ic];
        if LAB(i,j)~= 1;
           if j < Nc & LAB(i,j+1) ~= 1; LAB_POS(ic,1)=ic+1;  end;
           if i > 1  & LAB(i-1,j) ~= 1; LAB_POS(ic,2)=ic-Nc; end;
           if j > 1  & LAB(i,j-1) ~= 1; LAB_POS(ic,3)=ic-1;  end;
           if i < Nl & LAB(i+1,j) ~= 1; LAB_POS(ic,4)=ic+Nc; end;
        end;
        ic=ic+1;
    end;
end;

% PASSO 3: Definicao inicial da matriz LAB_PROP
rand('state',0);
% LAB_PROP indica a probabilidade calculada para a execucao de um certo
% movimento
% LAB_PROP(i,j) indica a probabilidade de execucao do movimento com destino
% 'a celula LAB_POS(i,j) a partir da celula i.
% A soma de cada linha de LAB_PROP deve ser sempre igual a 1.
[Ncel,Nmov]=size(LAB_POS);
LAB_PROP=(1/Nmov)*ones(size(LAB_POS));
%LAB_PROP, pause(1);
% LAB_END indica a numeracao das celulas terminais e das celulas
% nao-validas
LAB_END=[]; ip=0;
for i=1:Ncel;
    if (LAB_REC(i) == rec_pos) | (LAB_REC(i) == rec_neg) | (LAB_REC(i) == rec_neginf);
       LAB_END=[LAB_END; i];
    end;
end;
%% Verificacao preliminar dos dados de entrada   
if length(LAB_REC) ~= Ncel;
   error('Erro na definicao de LAB_POS ou de LAB_REC');
end;
if length(LAB_END) == 0;
   error('Erro na definicao de LAB_END');
end;
mov_hist={};  % empty cell to hold the history of each iteration

% PASSO 5: Loop de aprendizado usando o metodo Bootstrap Learning
for iter=1:NIterMax;  % loop de iteracoes
    % Defina as probabilidades acumuladas
    LAB_PROP_SUM(:,1)=LAB_PROP(:,1);
    for j=2:Nmov;
        LAB_PROP_SUM(:,j)=LAB_PROP_SUM(:,j-1)+LAB_PROP(:,j);
    end;
    % Selecione aleatoriamente o ponto de partida
    h(1)=ceil(Ncel*rand);
    %h(1)=10;
    while (sum( h(end) == LAB_END ) ~= 0) | (max(LAB_PROP(h(end))) > 0.95);
          h(1)=ceil(Ncel*rand);
    end;
    k=1;
    % Defina o proximo movimento enquanto nao for excedido o numero
    % maximo de iteracoes e nenhuma celula terminal tiver sido alcancada
    while (k <= NStepMax) & (sum( h(end) == LAB_END ) == 0);
          p(k)=rand;
          q(k)=sum(p(k)<=LAB_PROP_SUM(h(k),:));
          h(k+1)=LAB_POS(h(k),Nmov-q(k)+1);
          k=k+1;
    end;
    mov_hist{iter}=h;
    mov_hist_end(iter)=h(end);
    mov_hist_len(iter)=length(mov_hist{iter});
    clear p q;
    %h, %pause(1);
    % LEARNING
    %if (sum( h(end) == LAB_END ) ~= 0) & mov_hist_len(iter) > 1;
    if mov_hist_len(iter) > 1;
       %disp(['Learning at iteration ' num2str(iter)]);
       %if (LAB_REC(h(end)) == rec_neg) | (LAB_REC(h(end)) == rec_pos);
          %if LAB_REC(h(end)) == rec_neg; feed_rec=rec_neg; end;
          %if LAB_REC(h(end)) == rec_pos; feed_rec=rec_pos; end;
          feed_rec=LAB_REC(h(end));
          if (mov_hist_len(iter) >= NStepMax) & (LAB_REC(h(end)) == rn);
              feed_rec=2*rn;
          end;
          %disp(['Feedback da recompensa =  ' num2str(feed_rec)]);
          %disp(['Number of movements =  ' num2str(mov_hist_len(iter))]);
          %pause(1);
          for k=1:mov_hist_len(iter)-1;
              pmov=(LAB_POS(h(k),:)==h(k+1)); % mais de um movimento pode levar a mesma posicao
              %pmov, pause;
              for j=1:Nmov;
                  if pmov(j)==1;
                     LAB_PROP(h(k),j)=(1+feed_rec/10)*LAB_PROP(h(k),j);
                     if LAB_PROP(h(k),j) < 0; LAB_PROP(h(k),j)=0; end;
                  end;
              end;
              LAB_PROP(h(k),:)=LAB_PROP(h(k),:)/sum(LAB_PROP(h(k),:));
              %LAB_PROP(h(k),:),
          end;
          %end;
    end;
    %clear h;
    % Mostrar o status da aprendizagem armazenado na matriz LAB_PROP
    if iter==1; % tracar a grade e colocar simbolos nos estados terminais
       for i=0:Nl; plot([0 Nc],[i i], '-b'); hold on; end;
       for j=0:Nc; plot([j j], [0 Nl],'-b'); end;
       axis equal; axis([-1 Nc+1 -1 Nl+1]);
       ic=1;
       for i=1:Nl;
           for j=1:Nc;
               if LAB(i,j)==1; plot(j-0.5,Nl-i+0.5,'xr'); end;
               if LAB(i,j)==2; plot(j-0.5,Nl-i+0.5,'*r'); end;
               if LAB(i,j)==3; plot(j-0.5,Nl-i+0.5,'ob'); end;
               ic=ic+1;
           end;
       end;
       str=['>^<v']; dx=[-0.5 0 0.5 0]; dy=[0 -0.5 0 0.5];
    end;
    %
    if iter >= 1;
       ic=1;
       title(['Iteracao = ' num2str(iter) '/ ' num2str(NIterMax)]);
       for i=1:Nl;
           for j=1:Nc;
               [Prob_max,Mov_max]=max(LAB_PROP(ic,:));
               if LAB(i,j)==0;
                  if iter > 1; delete(hp(ic)); delete(hp2(ic)); end;
                  hp(ic)=plot(j-0.5,Nl-i+0.5,[str(Mov_max) 'k']);
                  hp2(ic)=plot([j-0.5 j-0.5+dx(Mov_max)],[Nl-i+0.5 Nl-i+0.5+dy(Mov_max)],'k-');
               end;
               ic=ic+1;
           end;
       end;
       if iter > 1; for ic=1:length(h2)-1; delete(hp3(ic)); end; end;
       for i=2:length(h);
           hi(1)=fix((h(i-1)-0.1)/Nc)+1;
           hi(2)=fix((h(i)  -0.1)/Nc)+1;
           hj(1)=h(i-1)-(hi(1)-1)*Nc;
           hj(2)=h(i)  -(hi(2)-1)*Nc;
           hp3(i-1)=plot([hj(1)-0.5 hj(2)-0.5],[Nl-hi(1)+0.5 Nl-hi(2)+0.5],'r-');
       end;
       h2=h;
    end;  
    drawnow;
    clear h;
    if iter==1; disp('PAUSE !!'); pause; disp('OUT OF PAUSE'); end;
end;
for ic=1:length(h2)-1; delete(hp3(ic)); end;
disp(['Media do no. de movimentos em cada iteracao = ' num2str(mean(mov_hist_len))]);
disp('LAB_PROP = ');
for i=1:size(LAB_PROP,1);
    fprintf('\n %6.3f %6.3f %6.3f %6.3f',LAB_PROP(i,:));
end;
 
 % EOF
 